// Thread2.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);


/**********************************************************************************

	 Process  first thraed called when start the Program

*************************************************************************************/

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_THREAD2, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_THREAD2);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_THREAD2);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_THREAD2;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}



// First Thread Functions


struct thread1
{
	HWND hwnd1;
	int no1;
};

thread1 obj1;

UINT ThreadProc1(LPVOID lpvoid);

UINT ThreadProc1(LPVOID lpvoid)
{


	thread1 *temp = (thread1*)lpvoid;
	HWND hwnd= temp->hwnd1;
	int no = temp->no1;
	char buff[200];
	HDC hdc= GetDC(hwnd);

	for(int i=0;i<no;i++)
	{
		wsprintf(buff,"Thread 1 Function : %d",i+1);
		TextOut(hdc,100,50,(LPCTSTR)buff,strlen(buff));
		Sleep(50);
	}

	return 0;
}


// Secoudn Functions


struct thread2
{
	HWND hwnd2;
	int no2;
};

thread2 obj2;

UINT ThreadProc2(LPVOID lpvoid);

UINT ThreadProc2(LPVOID lpvoid)
{


	thread2 *temp = (thread2*)lpvoid;
	HWND hwnd= temp->hwnd2;
	int no = temp->no2;
	char buff[200];
	HDC hdc= GetDC(hwnd);

	for(int i=0;i<no;i++)
	{
		wsprintf(buff,"Thread 2 Function :%d",i+1);
		TextOut(hdc,448,50,(LPCTSTR)buff,strlen(buff));
		Sleep(75);
	}

	return 0;
}



//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);

	char string[] = "Hello World!";
	HANDLE hThrd1,hThrd2;


	int i = 0;
	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			
			// Run the first Thread

			obj1.hwnd1 = hWnd;
			obj1.no1 = 140;
			 hThrd1 = CreateThread(NULL,  // no security attributes 
							 0,                // use default stack size 
							 (LPTHREAD_START_ROUTINE) ThreadProc1, 
							 (LPVOID)&obj1, // param to thread func 
							 CREATE_SUSPENDED, // creation flag 
						 NULL);       // 
					 
			 ResumeThread(hThrd1);

			 SetThreadPriority(hThrd1,THREAD_PRIORITY_HIGHEST);

			 // Run the secound Thread

			obj2.hwnd2 = hWnd;
			obj2.no2 = 260;
			 hThrd2 = CreateThread(NULL,  // no security attributes 
							 0,                // use default stack size 
							 (LPTHREAD_START_ROUTINE) ThreadProc2, 
							 (LPVOID)&obj2, // param to thread func 
							 CREATE_SUSPENDED, // creation flag 
						 NULL);       // 
			 ResumeThread(hThrd2);
					 
			 SetThreadPriority(hThrd1,THREAD_PRIORITY_LOWEST);
	
		 EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
